/*
 * Copyright (c) 2014 Wind River Systems, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <string.h>
#include "vmipc.h"

static int fd;

void *ivshm_open(char *path, int length, int mmap_offset, int ptr_offset)
{
    void *memptr;

    length = length*1024*1024;

    if ((fd = open(path, O_RDWR)) == -1)
	{
	return (void *)-1;		
    }

    memptr = mmap(NULL, length, PROT_READ|PROT_WRITE, MAP_SHARED, fd, mmap_offset);

    if (memptr == (caddr_t)-1)
    {
        close (fd);
	return (void *)-1;
    }

    return memptr + ptr_offset;
}

void ivshm_close(void *memptr, int length)
{
    munmap(memptr, length);
    close(fd);
}

void ivshm_clean (void *memptr, int size)
{
    memset (memptr, 0, size);
}

void ivshm_show (void *ptr, int length)
{
    int i;
    char *char_array;

    printf("[IVSHMEM] ptr=%p\n", ptr);
    printf("[IVSHMEM] contents\n");
    char_array = (char *) ptr;
    for (i = 0; i < ((sizeof(char) * length)); i++)
        printf("%c", char_array[i]);

    printf("\n---\n");
}
